
format   pe64 console 6.0
include 'win64ax.inc'
entry    start
;//-----------
.data
struct TIME_ZONE_INFORMATION
  Bias             dd  0
  StandardName     dw  32 dup(0)
  StandardDate     SYSTEMTIME 
  StandardBias     dd  0
  DaylightName     dw  32 dup(0)
  DaylightDate     SYSTEMTIME 
  DaylightBias     dd  0
ends

tzInfo    TIME_ZONE_INFORMATION
sTime     SYSTEMTIME
lTime     SYSTEMTIME

fCreate   FILETIME
fAccess   FILETIME
fWrite    FILETIME

fData     WIN32_FIND_DATA
hFind     dd  0
tm1       dq  10000000
result    dq  0

tZone     db  10,'    TimeZoneInfo:  GMT -%d. %s',0
intTime   dq  0
buff      db  0
;//-----------
section '.code' code readable executable
start:   sub     rsp,8
         invoke  SetConsoleTitle,'**** Windows TimeDataStamp v0.1 ****'

;//-----      ----------------
         invoke  GetSystemTime,sTime
         invoke  GetLocalTime, lTime

        cinvoke  printf,<10,'     System time: ',0>
         mov     rsi,sTime
         call    PrintDateTime

        cinvoke  printf,<10,'      Local time: ',0>
         mov     rsi,lTime
         call    PrintDateTime

;//-----     ---------------------------------
         invoke  GetTimeZoneInformation,tzInfo
         mov     eax,[tzInfo.Bias]
         or      eax,eax
         jns     @f
         mov     byte[tZone+24],'+'
         neg     eax
@@:      mov     ecx,60
         xor     edx,edx
         div     ecx
         push    rax
         lea     rbx,[tzInfo.DaylightName]
         invoke  CharToOemW,rbx,buff
         pop     rax
        cinvoke  printf,tZone,rax,buff

;//-----   Windows   ------------------------
         invoke  GetTickCount64
         push    rax
         mov     rbx,1000
         xor     rdx,rdx
         div     rbx        ;//  
         mov     rbx,60
         xor     rdx,rdx
         div     rbx        ;//  
         xor     rdx,rdx
         div     rbx        ;//  
         mov     r10,rdx
         pop     rbx
@@:     cinvoke  printf,<10,\
                         10,'     TickCount64:  %u',\
                         10,'    Windows time:  %d hour, %02d minutes',10,0>,rbx,rax,r10

;//-----   Windows   ------------------
         invoke  QueryUnbiasedInterruptTime,intTime
         mov     rax,[intTime]
         mov     ebx,10000000
         xor     edx,edx
         div     rbx
         mov     ebx,60
         xor     edx,edx
         div     rbx
         xor     edx,edx
         div     rbx
         xchg    rbx,rdx
        cinvoke  printf,<10,' Interrupt ticks:  %I64d',\
                         10,'   Unibased time:  %d hour, %02d minutes',0>,[intTime],rax,rbx

;//-----  NTFS  GetFileTime() -----------------------
         invoke  _lopen,<'WinTime.exe',0>,OF_READ
         push    rax
         invoke  GetFileTime,eax,fCreate,fAccess,fWrite
         pop     rax
         invoke  _lclose,eax
        cinvoke  printf,<10,10,'  This file time -------------- ',0>
         invoke  FileTimeToSystemTime,fCreate,sTime
        cinvoke  printf,<10,'          Create: ',0>
         mov     rsi,sTime
         call    PrintDateTime
         invoke  FileTimeToSystemTime,fAccess,sTime
        cinvoke  printf,<10,'          Access: ',0>
         mov     rsi,sTime
         call    PrintDateTime
         invoke  FileTimeToSystemTime,fWrite,sTime
        cinvoke  printf,<10,'           Write: ',0>
         mov     rsi,sTime
         call    PrintDateTime

         invoke  GetSystemTimeAsFileTime,buff
        cinvoke  printf,<10,10,'  System as file:  struct FILETIME = %08x`%08x',10,0>,\
                               dword[buff+4],dword[buff]

;//-----  NTFS  FindFirst\NextFile() ----------------

        cinvoke  printf,<10,' Find files in current dir',\
                         10,' ---------------------------',0>

         invoke  FindFirstFile,<'*.exe',0>,fData
         mov     [hFind],eax
@next:   lea     rsi,[fData.ftCreationTime]
         invoke  FileTimeToSystemTime,esi,sTime

        cinvoke  printf,<10,' Created:',0>
         mov     rsi,sTime
         call    PrintDateTime
         lea     rbx,[fData.cFileName]
        cinvoke  printf,<'  %s',0>,rbx

         invoke  FindNextFile,[hFind],fData
         or      eax,eax
         jnz     @next

         invoke  FindClose,[hFind]

;//-----    UNIX ---------------------------------
@fileName:
        cinvoke  printf,<10,10,' EXE-file name..: ',0>
        cinvoke  scanf,<'%s',0>,buff

         invoke  _lopen,buff,OF_READ   ;//   
         cmp     eax,-1
         jnz     @f
        cinvoke  printf,<' ERROR! File not found.',0>
         jmp     @fileName

@@:      push    rax
         invoke  _lread,eax,buff,512   ;//     512 
         pop     rax
         invoke  _lclose,eax

         mov     rsi,buff
         mov     eax,[rsi + 3ch]  ;// -Header
         add     esi,eax
         mov     eax,[rsi + 8]    ;// TimeDateStamp
         push    rax
        cinvoke  printf,<' TimeDataStamp..: 0x%08x = ',0>,eax

         pop     rax
         xor     rdx,rdx
         mul     [tm1]
         mov     rbx,116444736000000000
         add     rax,rbx
         mov     [result],rax

         invoke  FileTimeToSystemTime,result,sTime
         mov     rsi,sTime
         call    PrintDateTime

@exit:  cinvoke  _getch
        cinvoke  exit,0
;//-----------
align 16
PrintDateTime:
         movzx   eax, [rsi+SYSTEMTIME.wDay]
         movzx   ebx, [rsi+SYSTEMTIME.wMonth]
         movzx   ebp, [rsi+SYSTEMTIME.wYear]
         movzx   edi, [rsi+SYSTEMTIME.wHour]
         movzx   r10d,[rsi+SYSTEMTIME.wMinute]
         movzx   r11d,[rsi+SYSTEMTIME.wSecond]
        cinvoke  printf,<' %02d.%02d.%d - %02d:%02d:%02d',0>,\
                           rax,rbx,rbp,rdi,r10,r11,r12
         ret
;//-----------
section '.idata'   import data readable
library  kernel32,'kernel32.dll',user32,'user32.dll',msvcrt,'msvcrt.dll'
include 'api\kernel32.inc'
include 'api\user32.inc'
include 'api\msvcrt.inc'




